class InputContext
  H_CONVERSION_TABLE = {
    ?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',
    ?k=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?k=>'@',
          ?y=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''}},
    ?s=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?s=>'@',
          ?y=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''},
          ?h=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''}},
    ?t=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?t=>'@',
          ?y=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''},
          ?h=>{?a=>'Ƥ',?i=>'Ƥ',?u=>'Ƥ',?e=>'Ƥ',?o=>'Ƥ'},
          ?s=>{?a=>'Ĥ',?i=>'Ĥ',?u=>'',?e=>'Ĥ',?o=>'Ĥ'}},
    ?n=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?n=>'',
         ?y=>{?a=>'ˤ',?i=>'ˤ',?u=>'ˤ',?e=>'ˤ',?o=>'ˤ'},
         ?k=>'@',?s=>'@',?t=>'@',?h=>'@',?m=>'@',?r=>'@',?g=>'@',
         ?z=>'@',?d=>'@',?b=>'@',?p=>'@',?f=>'@',?v=>'@',?x=>'@',
         ?w=>'@',?c=>'@',?j=>'@'},
    ?h=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?h=>'@',
          ?y=>{?a=>'Ҥ',?i=>'Ҥ',?u=>'Ҥ',?e=>'Ҥ',?o=>'Ҥ'}},
    ?m=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?m=>'@',
          ?y=>{?a=>'ߤ',?i=>'ߤ',?u=>'ߤ',?e=>'ߤ',?o=>'ߤ'}},
    ?y=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''},
    ?r=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?r=>'@',
          ?y=>{?a=>'',?i=>'ꤣ',?u=>'',?e=>'ꤧ',?o=>''}},
    ?w=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''},
    ?g=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?g=>'@',
          ?y=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''}},
    ?z=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?z=>'@',
          ?y=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''}},
    ?d=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?d=>'@',
          ?y=>{?a=>'¤',?i=>'¤',?u=>'¤',?e=>'¤',?o=>'¤'},
          ?h=>{?a=>'',?i=>'Ǥ',?u=>'ɤ',?e=>'Ǥ',?o=>'ɤ'}},
    ?b=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?b=>'@',
          ?y=>{?a=>'Ӥ',?i=>'Ӥ',?u=>'Ӥ',?e=>'Ӥ',?o=>'Ӥ'}},
    ?p=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?p=>'@',
          ?y=>{?a=>'Ԥ',?i=>'Ԥ',?u=>'Ԥ',?e=>'Ԥ',?o=>'Ԥ'}},
    ?c=>{?h=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''},
         ?y=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''},
         ?c=>'@',},
    ?f=>{?a=>'դ',?i=>'դ',?u=>'',?e=>'դ',?o=>'դ',
         ?f=>'@',},
    ?j=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',
         ?y=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''},
         ?j=>'@'},
    ?v=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?v=>'@'},
    ?x=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',
         ?t=>{?u=>''},
         ?w=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''}}
  }
  K_CONVERSION_TABLE = {
    ?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',
    ?k=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?k=>'@',
          ?y=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''}},
    ?s=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?s=>'@',
          ?y=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''},
          ?h=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''}},
    ?t=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?t=>'@',
          ?y=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''},
          ?h=>{?a=>'ƥ',?i=>'ƥ',?u=>'ƥ',?e=>'ƥ',?o=>'ƥ'},
          ?s=>{?a=>'ĥ',?i=>'ĥ',?u=>'',?e=>'ĥ',?o=>'ĥ'}},
    ?n=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?n=>'',
         ?y=>{?a=>'˥',?i=>'˥',?u=>'˥',?e=>'˥',?o=>'˥'},
         ?k=>'@',?s=>'@',?t=>'@',?h=>'@',?m=>'@',?r=>'@',?g=>'@',
         ?z=>'@',?d=>'@',?b=>'@',?p=>'@',?f=>'@',?v=>'@',?x=>'@',
         ?w=>'@',?c=>'@',?j=>'@'},
    ?h=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?h=>'@',
          ?y=>{?a=>'ҥ',?i=>'ҥ',?u=>'ҥ',?e=>'ҥ',?o=>'ҥ'}},
    ?m=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?m=>'@',
          ?y=>{?a=>'ߥ',?i=>'ߥ',?u=>'ߥ',?e=>'ߥ',?o=>'ߥ'}},
    ?y=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''},
    ?r=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?r=>'@',
          ?y=>{?a=>'',?i=>'ꥣ',?u=>'',?e=>'ꥧ',?o=>''}},
    ?w=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''},
    ?g=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?g=>'@',
          ?y=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''}},
    ?z=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?z=>'@',
          ?y=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''}},
    ?d=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?d=>'@',
          ?y=>{?a=>'¥',?i=>'¥',?u=>'¥',?e=>'¥',?o=>'¥'},
          ?h=>{?a=>'',?i=>'ǥ',?u=>'ɥ',?e=>'ǥ',?o=>'ɥ'}},
    ?b=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?b=>'@',
          ?y=>{?a=>'ӥ',?i=>'ӥ',?u=>'ӥ',?e=>'ӥ',?o=>'ӥ'}},
    ?p=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',?p=>'@',
          ?y=>{?a=>'ԥ',?i=>'ԥ',?u=>'ԥ',?e=>'ԥ',?o=>'ԥ'}},
    ?c=>{?h=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''},
         ?y=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''},
         ?c=>'@',},
    ?f=>{?a=>'ե',?i=>'ե',?u=>'',?e=>'ե',?o=>'ե',
         ?f=>'@',},
    ?j=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',
         ?y=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''},
         ?j=>'@'},
    ?v=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''},
    ?x=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>'',
         ?t=>{?u=>''},
         ?w=>{?a=>'',?i=>'',?u=>'',?e=>'',?o=>''}}
  }
  SPECIAL_TABLE = {
    ?!=>'', ?-=>'',?[=>'',?]=>'',?:=>'',?;=>'',
    ?,=>'', ?.=>'',??=>''
  }

  def InputContext.kuten(x)
    SPECIAL_TABLE[?.] = x
  end
  def InputContext.touten(x)
    SPECIAL_TABLE[?,] = x
  end
  def initialize(screen,output)
    @screen = screen
    @output = output
    @table = H_CONVERSION_TABLE
    @conv = @table
    @conso = []
    @wait_moment = false
  end
  def putc(c)
    while true
      s = @conv[c]
      case s
      when Hash
        @conv = s
        @conso.push(c)
        @screen.putc(c)
        @screen.flush
      when String
        if s[0] == ?@
          clear_conso(s.size-1)
          @screen.flush
          @output.print(s[1,s.size-1])
          @output.flush
          @conv = @table
          sleep(0.01)    # wait for the output character to echo back
          redo
        else
          clear_conso(s.size)
          @screen.flush
          @output.print(s)
          @output.flush
          @conv = @table
        end
      when nil
        if @conv == @table then
           clear_conso
           if SPECIAL_TABLE.key?(c) then
             @output.print(SPECIAL_TABLE[c])
           else
             @output.print c.chr
           end
           @output.flush
        else
           @conv = @table
           @screen.left(@conso.size)
           @conso = []
           redo
        end
      end
      break
    end
  end
  def conso_size
    @conso.size
  end
  def output
    @output
  end
  def clear_conso(n = 0)
    if @conso.size <= n then
      @screen.left(@conso.size)
    else
      @screen.erase_before(@conso.size)
    end
    @conso = []
  end
  def clear
    @conso = []
    @conv = @table
    if @output.erasable? then
      @output.clear
    end
    self
  end
  def toggle
    if @table == H_CONVERSION_TABLE then
      @table = K_CONVERSION_TABLE
      ret = ""
    else
      @table = H_CONVERSION_TABLE
      ret = ""
    end
    if @conso.size > 0 then
      clear_conso(0)
    end
    @conv = @table
    return status
  end
  def to_hiragana
    if @conso.size > 0 then
      clear_conso(0)
    end
    @table = H_CONVERSION_TABLE
    @conv = @table
  end
  def to_katakana
    if @conso.size > 0 then
      clear_conso(0)
    end
    @table = K_CONVERSION_TABLE
    @conv = @table
  end
  def flush_conso
    if @conso.size == 1 and @conso[0] == ?n then
      putc(?n)
    end
    clear_conso(0)
  end
  def status
    if @table == H_CONVERSION_TABLE then
      ""
    else
      ""
    end
  end
  def erase
    if @conso.size > 0 then
      @conso.pop
      @conv = @table
      for c in @conso
        @conv = @conv[c]
      end
      @screen.erase_before(1)
      @screen.flush
      true
    elsif @output.erasable? then
      @output.erase
    else
      false
    end
  end
end

class PseudoIOBuffer
  def initialize(screen,clearok=true)
    @buffer = []
    @screen = screen
    @clear_ok = clearok
  end
  def print(*arg)
    for a in arg
      s = a.to_s
      c = ''
      status = :ascii
      s.each_byte do |b|
        if b > 128 then
          if status == :kanji1 then
            status = :kanji2
            @buffer.push c+b.chr
          else
            status = :kanji1
            c = b.chr
          end
        else
          @buffer.push b.chr
        end
      end
      @screen.print s 
    end
    @screen.flush
  end
  def putc(c)
    @buffer.push(c.chr)
    self
  end
  def get
    @buffer.join('')
  end
  def erasable?
    true
  end
  def erase
    if @buffer.size >= 1 then
      x = @buffer.pop
      @screen.erase_before(x.size)
      @screen.flush
      true
    else
      false
    end
  end
  def flush
    # dummy
    self
  end
  def size
    @buffer.size
  end
  def clear
    if @clear_ok
      @buffer = []
    end
    self
  end
  def clear!
    @buffer = []
    self
  end
end
      
  